/*
 * @author _Tobias
 * @script gadget
 * @version 1.9
 */

var Gadget = function() {
	var __construct = function() {
		// workaround for rockradio (no premium service)
		if(network == 'rockradio.com') premium = false;

		// set up setting dialog
		System.Gadget.settingsUI = 'settings.html';
		System.Gadget.onSettingsClosed = function() {
			if(typeof System.Gadget.Settings.read('change') == 'boolean') {
				// reset the change indicator
				System.Gadget.Settings.write('change', '');
				// reload gadget
				location.href = location.href;
			}
		}

		// bind channel change
		document.getElementById('selector').onchange = function() {
			if(!playing) channel = this.value;
			else play(this.value);
			this.blur();
		};

		// unselect select box
		document.getElementsByTagName('select')[0].blur();

		// hide the control button
		document.getElementById('switchwrap').style.display = 'none';

		// show current volume
		document.getElementById('vol').innerText = volume;

		// bind volume controls
		document.getElementById('volplus').onclick = document.getElementById('volplus').ondblclick = function() {
			if(volume>95) return updateVol(100);
			updateVol(volume+5);
			this.blur();
		}

		document.getElementById('volmin').onclick = document.getElementById('volmin').ondblclick = function() {
			if(volume<5) return updateVol(0);
			updateVol(volume-5);
			this.blur();
		}

		// bind stop/play
		document.getElementById('switch').onclick = function() {
			document.getElementById('switch').innerText = playing ? 'Play' : 'Stop';
			if(playing) stop();
			else play();
			this.blur();
		}

		// bind search track
		document.getElementById('npwrap').ondblclick = function() {
			window.open('http://www.google.com/search?q='+encodeURIComponent(document.getElementById('np').innerText));
		}

		// header
		document.getElementById('title').innerText = networkData[network].name+' Gadget';

		// read version from xml manifest
		// set up objects
		var xml = new ActiveXObject('Microsoft.XMLDOM');

		// parse xml
		xml.loadXML(fileHandler.read('gadget.xml'));

		// check for updates
		version = xml.getElementsByTagName('version')[0].childNodes[0].nodeValue.replace('.', '');

		// check for updates
		loadScript('http://gadget.tobiass.eu/update.jsonp.php?callback=Gadget.version');

		// start init process
		loadScript('http://listen.'+network+'/p.jsonp?callback=Gadget.data');
	},

	play = function(a) {
		// if no string is given, use channel or, when channel is empty, defaultChannel
		channel = (typeof a == 'string' ? a : (channel.length>0 ? channel : defaultChannel));

		System.Gadget.Settings.write('channel', channel);

		var addkey = (premium ? '?'+premium : '');
		var quality = (premium ? qualities[high] : qualities.free);

		playing = true;

		// when wmp is initialized
		if(document.getElementById('wmpwrap').innerHTML.length>0) {
			if(!pos) animateOpen();
			loadScript('http://listen.'+network+'/'+quality+'/'+channel+'.jsonp'+addkey+(addkey.length>0 ? '&' : '?')+'callback=Gadget.streams');
			loadHistory();
		}
		// if not, init wmp
		else {
			document.getElementById('wmpwrap').innerHTML = '<object classid="clsid:6BF52A52-394A-11d3-B153-00C04F79FAA6" width="181" height="25" type="application/x-oleobject" id="wmp"><param name="url" value="" /><param name="volume" value="'+volume+'" /><param name="uimode" value="none" /><param name="showcontrols" value="true" /></object>';
			document.getElementsByTagName('OBJECT')[0].controls.stop();
			playing = false;
		}

	},

	stop = function() {
		if(pos) animateClose();
		playing = false;
		document.getElementById('np').innerText = '';
		if(document.getElementById('wmpwrap').innerHTML.length>0) document.getElementsByTagName('OBJECT')[0].controls.stop();
	},

	updateVol = function(a) {
		volume = a;
		var str = a.toString();
		document.getElementById('vol').innerText = str;
		document.getElementsByTagName('OBJECT')[0].settings.volume = volume;
		System.Gadget.Settings.write('volume', volume);
	},

	loadData = function(data) {
		data.sort(function(a, b) {
			var nameA = a.name.toLowerCase(), nameB = b.name.toLowerCase();
			if (nameA < nameB) return -1;
			if (nameA > nameB) return 1;
			return 0;
		});

		var channelExists = false;

		for(var i=0; i<data.length; i++) {
			var v = data[i];
			if(v.key == channel) channelExists = true;
			if(networkData[network].channel == v.key) {
				defaultChannel = v.key;
			}
		}

		clearTimeout(error);

		document.getElementById('selector').remove(0);

		for(var i=0; i<data.length; i++) {
			var v = data[i];
			var active = false;

			ids[v.key] = v.id;

			// active channel
			if(channel == v.key) active = true;

			// when there's no active channel, get the default channel.
			else if(!channelExists && defaultChannel == v.key) active = true;
			document.getElementById('selector').options[document.getElementById('selector').options.length] = new Option(v.name, v.key, false, active);
		}

		// unhide the control button
		document.getElementById('switchwrap').style.display = '';

		// in case another network is chosen, there might be a change that the current channel doesn't exist
		if(!channelExists) {
			channel = '';
		}

		// start playing
		play();
	},

	animateOpen = function() {
		var j = 70;
		var interval = setInterval(function() {
			if(j == 115) return clearInterval(interval);
			document.body.style.height = j;
			j++;
		}, 2);
		pos = true;
	},

	animateClose = function() {
		var j = 113;
		var interval = setInterval(function() {
			if(j == 69) return clearInterval(interval);
			document.body.style.height = j;
			j--;
		}, 2);
		pos = false
	},

	loadStreamAsx = function(streams) {
		var counter = 1;
		var asxStr = '<asx version = "3.0">\n<REPEAT>\n';
		for(var i=0; i<streams.length; i++) {
			if(streams[i].indexOf('.pls') == -1) {
				// workaround for premium wma streams
				if(streams[i].indexOf('mms://') === 0) {
					streams[i] = streams[i].replace('?', '?user=h&pass=');
				}
				asxStr += '<entry>\n<title>Server #'+(i+1)+'</title>\n<ref href="'+streams[i]+'"/>\n</entry>\n';
			}
		}
		asxStr += '</REPEAT>\n</asx>';
		document.getElementsByTagName('OBJECT')[0].url = fileHandler.write('play.asx', asxStr);
	},

	loadVersion = function(newest) {
		if(version<newest) {
			document.getElementById('title').innerText = 'Update available!';
			setTimeout(function() {
				document.getElementById('title').innerText = networkData[network].name;
			}, 10000)
		}
	},

	loadScript = function(url) {
		// get random number
		var random = Math.round((new Date).getTime()*Math.random());
		// append random
		url += url.indexOf('?') != -1 ? '&'+random : '?'+random;
		// create empty script element
		var cb = document.createElement('SCRIPT');
		// set script url
		cb.src = url;
		// fetch/eval script
		document.getElementsByTagName('HEAD')[0].appendChild(cb);
	},

	loadHistory = function(data) {
		if(typeof data === 'undefined')
			return loadScript('http://api.audioaddict.com/v1/di/track_history/channel/'+ids[channel]+'.jsonp?callback=Gadget.history');
		var current;
		for(var i in data) {
			if(data[i].type != 'advertisement' && !current)
				current = data[i];
		}

		var now = Math.floor((new Date).getTime()/1000);
		var end = current.started+current.duration;
		if(end > now) { // Track is still playing
			document.getElementById('np').innerText = current.track;
			setTimeout(function() {
				loadHistory();
			}, (end-now)*1000)
		}
		else {
			setTimeout(loadHistory, 5000);
		}
			
	},

	errorFn = function() {
		clearTimeout(error);
		document.getElementById('selector').remove(0);
		document.getElementById('selector').options[document.getElementById('selector').options.length] = new Option('Internet not available', '', false, true);
		document.getElementById('switchwrap').style.display = '';
		document.getElementById('switchwrap').style.marginLeft = -107;
		document.getElementById('switchwrap').innerHTML = '<a href="javascript:void(0)" onclick="location.reload()">Retry</a>';
	},

	error = setTimeout(errorFn, 2500),

	qualities = {
		high: 'premium_high',
		medium: 'premium_wma',
		free: 'public3'
	},
	premium = System.Gadget.Settings.read('premium').length>0 ? System.Gadget.Settings.read('premium') : false,
	high = System.Gadget.Settings.read('high').length>0 ? System.Gadget.Settings.read('high') : 'high',
	playing = false,
	volume = typeof System.Gadget.Settings.read('volume') == 'number' ? System.Gadget.Settings.read('volume') : 70,
	network = System.Gadget.Settings.read('network').length>0 ? System.Gadget.Settings.read('network') : 'di.fm',
	networkData = {
		'di.fm': {
			channel: 'trance',
			name: 'DI Radio'
		},
		'sky.fm': {
			channel: 'tophits',
			name: 'SKY.FM Radio'
		},
		'rockradio.com': {
			channel: 'classicrock',
			name: 'RockRadio'
		},
		'jazzradio.com': {
			channel: 'classicjazz',
			name: 'JazzRadio'
		}
	},
	channel = System.Gadget.Settings.read('channel'),
	version,
	pos = false,
	ids = {},
	defaultChannel;

	return {
		init: __construct,
		data: loadData,
		version: loadVersion,
		streams: loadStreamAsx,
		history: loadHistory
	}
}();

window.onload = Gadget.init;