/*
 * jQuery throttle / debounce - v1.1 - 3/7/2010
 * http://benalman.com/projects/jquery-throttle-debounce-plugin/
 * 
 * Copyright (c) 2010 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
(function(b,c){var $=b.jQuery||b.Cowboy||(b.Cowboy={}),a;$.throttle=a=function(e,f,j,i){var h,d=0;if(typeof f!=="boolean"){i=j;j=f;f=c}function g(){var o=this,m=+new Date()-d,n=arguments;function l(){d=+new Date();j.apply(o,n)}function k(){h=c}if(i&&!h){l()}h&&clearTimeout(h);if(i===c&&m>e){l()}else{if(f!==true){h=setTimeout(i?k:l,i===c?e-m:e)}}}if($.guid){g.guid=j.guid=j.guid||$.guid++}return g};$.debounce=function(d,e,f){return f===c?a(d,e,false):a(d,f,e!==false)}})(this);


/*
 * @author _Tobias
 * @script settings
 * @version 1.9
 */

var version;

window.onload = function() {

	// unselect select
	document.getElementsByTagName('select')[0].blur();

	// read out all values
	document.getElementById('network').selectedIndex = System.Gadget.Settings.read('networkIndex');
	document.getElementById('premium').value = System.Gadget.Settings.read('premium');
	document.getElementById('premium').style.backgroundColor = System.Gadget.Settings.read('premium').length>0 ? '#76F76F' : 'white';
	document.getElementById('high').checked = System.Gadget.Settings.read('high') == 'medium' ? false : true;
	document.getElementById('highwrap').style.display = keyval(document.getElementById('premium').value) ? '' : 'none';
	document.getElementById('premium').onkeyup = Cowboy.debounce(180, function() {
		settings('premium', document.getElementById('premium').value);
		if(keyval(document.getElementById('premium').value)) {
			document.getElementById('premium').style.backgroundColor = '#76F76F';
			document.getElementById('highwrap').style.display = '';
			document.body.style.height = '292px';
		}
		else {
			document.getElementById('highwrap').style.display = 'none';
			document.body.style.height = '280px';
			document.getElementById('premium').style.backgroundColor = document.getElementById('premium').value.length>0 ? '#FC8686' : 'white';
		}
	});

	document.getElementById('network').onchange = function() {
		settings('network', this.value);
		settings('networkIndex', this.selectedIndex);
		document.getElementById('premwrap').style.display = this.selectedIndex == 3 ? 'none' : '';
		document.body.style.height = this.selectedIndex == 3 ? '165px' : (document.getElementById('highwrap').style.display == '' ? '292px' : '280px');
	}
	document.getElementById('network').onchange();

	// check for updates
	
	// read version from xml manifest
	// set up objects
	var xml = new ActiveXObject('Microsoft.XMLDOM');

	// parse xml
	xml.loadXML(fileHandler.read('gadget.xml'));

	// check for updates
	version = xml.getElementsByTagName('version')[0].childNodes[0].nodeValue.replace('.', '');
	checkUpdate();
}

var keyval = function(a) {
	if(/^[a-f0-9]+$/.test(a) && a.length>12) {
		var xhr = new ActiveXObject('MSXML2.XMLHTTP.3.0');
		xhr.open('POST', 'http://tobiass.eu/api/key/post', false);
		xhr.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
		xhr.send('key='+a+'&type=text');
		return xhr.responseText.split('|')[0] == 'true';
	}
	else return false;
}

// delay saving settings
var settings = function() {
	var data = {},
	change = false;
	return function(a,b) {
		if(typeof b == 'undefined' && typeof a == 'boolean') {
			// apply
			if(change) {
				// when the key ain't valid, or rockradio is selected, don't save the key
				if(!keyval(document.getElementById('premium').value) || document.getElementById('network').selectedIndex == 3) {
					data['premium'] = '';
					data['high'] = '';
				}

				// let the gadget know we changed stuff
				data['change'] = true;
				// save everything
				for(var i in data) {
					System.Gadget.Settings.write(i, data[i]);
				}
			}
		}
		else {
			// query
			data[a] = b;
			// mark that there were changes
			change = true;
		}
	}
}();

System.Gadget.onSettingsClosing = function(event) {
	// ok
    if (event.closeAction == event.Action.commit) {
    	// save settings
    	return settings(true);
    }
    // make dialog closable
    event.cancel = false;
};

var checkUpdate = function() {
	document.getElementById('update').innerText = 'Checking...';

	// error catcher
	var errorFn = function() {
		clearTimeout(error);
		document.getElementById('update').innerHTML = 'Update server or internet not available. <a href="javascript:void(0)" onclick="checkUpdate()">Retry</a>';
	}
	var error = setTimeout(errorFn, 2500);

	// checking for updates using xhr
	var xhr = new ActiveXObject('MSXML2.XMLHTTP.3.0');
	xhr.open('GET', 'http://gadget.tobiass.eu/update'+anticache(), true);
	xhr.onreadystatechange = function() {
		if(xhr.readyState == 4 && xhr.status == 200) {
			if(version<xhr.responseText) {
				document.getElementById('update').innerHTML = 'Version '+xhr.responseText.split('').join('.')+' available!<br /><a href="javascript:void(0)" onclick="updateTo('+xhr.responseText+')"><b>Download</b></a>';
			}
			else if(version>xhr.responseText) {
				document.getElementById('update').innerHTML = 'You\'re using some weird version...<br /><a href="javascript:void(0)" onclick="updateTo('+xhr.responseText+')"><b>Download latest</b></a>';
			}
			else {
				document.getElementById('update').innerHTML = "You're using the latest version, "+version.split('').join('.')+".";
			}
			clearTimeout(error);
		}
		else if(xhr.readyState == 4 && xhr.status == 12007) {
			errorFn();
		}
	}
	xhr.send();
}

var anticache = function() {
	return '?'+Math.round((new Date).getTime()*Math.random());
}

var updateTo = function(v) {
	var ready = 0;
	v = v.toString().split('').join('.');
	var getFile = function(f) {
		var xhr = new ActiveXObject('MSXML2.XMLHTTP.3.0');
		xhr.open('GET', 'http://gadget.tobiass.eu/source/'+v+'/'+f+anticache(), true);
		xhr.onreadystatechange = function() {
			if(xhr.readyState == 4) {
				fileHandler.write(f, xhr.responseText);
				ready++;
			}
		}
		xhr.send();
	}

	// files to update

	var files = ['gadget.js', 'gadget.css', 'gadget.html', 'settings.js', 'settings.html', 'settings.css', 'gadget.xml', 'filehandler.js'];

	document.getElementById('update').innerText = 'Updating to version '+v+'...';

	for(var i in files) {
		getFile(files[i]);
	}

	// check if ready every 20ms
	var loopie = setInterval(function() {
		if(ready == files.length) {
			document.getElementById('update').innerText = 'Updated to version '+v+'.';
			settings('change', 'yup');
			clearInterval(loopie);
		}
	}, 20);
}